Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# IdeFileSystem Class Reference

base interface class for all filesystems. More...

`#include <deFileSystem.hpp>`

Inheritance diagram for IdeFileSystem:

[legend]
Collaboration diagram for IdeFileSystem:

[legend]
List of all members.

## Public Types
enum | interface_t { iface_IdeFileSystem = 0, iface_IdeFSReal, iface_IdeFSMemory, iface_IdeFSVirtual, iface_force_32bit = 0x7FFFFFFF }
| Possible interfaces for the filesystem. More...
## Public Member Functions
virtual void * | GetInterface (IdeFileSystem::interface_t i)=0
virtual IdeFile * | Open (const char *Filename, long OpenFlags)=0
virtual const char * | GetDirectory ()=0
| Get the current directoriy.
virtual deBoolean | SetDirectory (const char *Directory)=0
| Set the current directory.
virtual deBoolean | Rename (const char *OldFilename, const char *NewFilename)=0
virtual deBoolean | Delete (const char *Filename, deFSPROGRESS StatusCallback)=0
virtual deBoolean | Move (const char *OldFilename, const char *NewFilename, deFSPROGRESS StatusCallback)=0
virtual deBoolean | Copy (const char *OldFilename, const char *NewFilename, deFSPROGRESS StatusCallback)=0
virtual deBoolean | AddDirectory (const char *Directory)=0
virtual deBoolean | DeleteDirectory (const char *Directory, deFSPROGRESS StatusCallback)=0
virtual void * | FindFirst (const char *Pattern, deFileProperties *Properties)=0
virtual deBoolean | FindNext (void *Handle, deFileProperties *Properties)=0
virtual deBoolean | FindEnd (void *Handle)=0
## Protected Member Functions
virtual | ~IdeFileSystem ()

## Detailed Description

base interface class for all filesystems.

## Member Enumeration Documentation

enum IdeFileSystem::interface_t

  | Possible interfaces for the filesystem. Enumeration values:
  iface_IdeFileSystem |
  iface_IdeFSReal |
  iface_IdeFSMemory | Real files.
  iface_IdeFSVirtual | Files stored in memory.
  iface_force_32bit | Virtual File System.

## Constructor & Destructor Documentation

virtual IdeFileSystem::~IdeFileSystem | ( |  | ) | `[inline, protected, virtual]`

## Member Function Documentation

virtual deBoolean IdeFileSystem::AddDirectory | ( | const char * | Directory | ) | `[pure virtual]`

  | Create a directory Parameters:
  in] | Directory The name of the directory
Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual deBoolean IdeFileSystem::Copy | ( | const char * | OldFilename,
|  | const char * | NewFilename,
|  | deFSPROGRESS | StatusCallback
| ) | `[pure virtual]`

  | Copy a file Parameters:
  in] | Filename File to copy
  in] | StatusCallback Pointer to a function to call while copying, pass a NULL for no callbacks
Returns: True/False if the copy was successful Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual deBoolean IdeFileSystem::Delete | ( | const char * | Filename,
|  | deFSPROGRESS | StatusCallback
| ) | `[pure virtual]`

  | Delete a file Parameters:
  in] | Filename File to Delete
  in] | StatusCallback Pointer to a function to call while deleting, pass a NULL for no callbacks
Returns: True/False if the delete was successful Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual deBoolean IdeFileSystem::DeleteDirectory | ( | const char * | Directory,
|  | deFSPROGRESS | StatusCallback
| ) | `[pure virtual]`

  | Delete a directory Parameters:
  in] | Name of the directory to delete
  in] | StatusCallback Pointer to a function to call while deleting, pass a NULL for no callbacks
Returns: True/False if the delete was successful Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual deBoolean IdeFileSystem::FindEnd | ( | void * | Handle | ) | `[pure virtual]`

  | Finish a find and cleanup any memory usage Parameters:
  in] | Handle Find to finish
Returns: True if the find is done, False if there was a problem Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual void* IdeFileSystem::FindFirst | ( | const char * | Pattern,
|  | deFileProperties * | Properties
| ) | `[pure virtual]`

  | Start a find on the filesystem Parameters:
  in] | Pattern Pattern to match the files to. ? to match 1 character, * for multiple character matching
  out] | Properties Information about the first file found that matches
Returns: A value used to identify the find for later finds Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual deBoolean IdeFileSystem::FindNext | ( | void * | Handle,
|  | deFileProperties * | Properties
| ) | `[pure virtual]`

  | Find the next file in the list that matches Parameters:
  in] | Handle Value returned by FindFirst
  out] | Properties Information about the file found that matches
Returns: True if a file was found, False if no more files exist Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual const char* IdeFileSystem::GetDirectory | ( |  | ) | `[pure virtual]`

| Get the current directoriy. Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual void* IdeFileSystem::GetInterface | ( | IdeFileSystem::interface_t | i | ) | `[pure virtual]`

  | Function to obtain the proper interface for the filesystem Parameters:
  in] | i Input for the type of interface to return
Returns: Returns a pointer to the requested interface or NULL if an invalid interface Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual deBoolean IdeFileSystem::Move | ( | const char * | OldFilename,
|  | const char * | NewFilename,
|  | deFSPROGRESS | StatusCallback
| ) | `[pure virtual]`

  | Move a file Parameters:
  in] | Filename File to move
  in] | StatusCallback Pointer to a function to call while moving, pass a NULL for no callbacks
Returns: True/False if the move was successful Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual IdeFile* IdeFileSystem::Open | ( | const char * | Filename,
|  | long | OpenFlags
| ) | `[pure virtual]`

  | Open a file Parameters:
  in] | Filename Filename to open
  in] | OpenFlags flags for opening the filesystem deFile_Open_Create Create a file, fail if it exists deFile_Open_Existing Open an existing file, fail it if does not exist deFile_Open_Always Always open the file, create if it does not exist or open existing deFile_Open_CreateAlways Always open the file, override if the file already exists
Returns: Return a pointer to an IdeFile class if valid Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual deBoolean IdeFileSystem::Rename | ( | const char * | OldFilename,
|  | const char * | NewFilename
| ) | `[pure virtual]`

  | Rename a file Parameters:
  in] | OldFilename Original file to rename
  in] | NewFilename New name for the file
Returns: True/False if the rename was successful Implemented in deFileSystem, deFSReal, and deFSVirtual.

virtual deBoolean IdeFileSystem::SetDirectory | ( | const char * | Directory | ) | `[pure virtual]`

| Set the current directory. Implemented in deFileSystem, deFSReal, and deFSVirtual.

The documentation for this class was generated from the following file:

- deFileSystem.hpp